Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0007598OCamllexing and parsingpublic2017-07-25 14:082017-10-19 15:24
Reporterbartjacobs 
Assigned Todoligez 
PrioritynormalSeveritycrashReproducibilityalways
StatusresolvedResolutionfixed 
Platformx64OSmacosOS Version10.11.6
Product Version4.05.0 
Target Version4.06.0+devFixed in Version4.06.0+dev 
Summary0007598: Out-of-date camlp4 causes segfault in ocamlopt.opt
DescriptionSuggested fix: add code to detect incompatibility and produce helpful error message.
Steps To ReproduceInstall version 4.05 of OCaml and 4.04+1 of camlp4. Create file foo.ml containing the text

type bar = < quux: unit >

Run

ocamlopt.opt -c -pp camlp4o.opt foo.ml

This creates a segfault. See the OS X crash report attached.
TagsNo tags attached.
Attached Files? file icon ocamlopt.opt_2017-07-25-134408_Bart-Jacobss-MacBook-Pro.crash [^] (11,194 bytes) 2017-07-25 14:08

- Relationships
related to 0007599acknowledged Document why, when and how to update magic numbers 

-  Notes
(0018137)
gasche (developer)
2017-07-25 21:38

(to devs) I would assume that the AST magic number should have been checked before deserialization of the AST. Does this report suggest that we have forgotten to update the AST magic number between 4.04 and 4.05? If so, then we could fix this in the 4.05 branch and in trunk.
(0018306)
xleroy (administrator)
2017-09-21 10:32

To show the updates to the AST magic numbers:
git log -L87,88:utils/config.mlp

Looks like they were updated in 4.03 and in 4.04 but not in 4.05 indeed.
(0018487)
doligez (administrator)
2017-10-05 17:39

See https://github.com/ocaml/ocaml/pull/1402 [^]
(0018561)
frisch (developer)
2017-10-13 20:55

Gabriel: you mentioned bumping magic number in 4.05? Do you know if a bug fix release on 4.05 is planned?
(0018563)
gasche (developer)
2017-10-13 21:43

I don't know, but we can discuss this.

Aside: I don't feel confident about magic numbers and I would be happier to let other people take care of it. For now they have been bumped in trunk, but not in the 4.06 release branch, so my impression is that something is still wrong.
(0018590)
xleroy (administrator)
2017-10-19 15:24

Magic numbers were bumped in 4.06. I'm skeptical about a new release of 4.05. Marking this PR as resolved.

- Issue History
Date Modified Username Field Change
2017-07-25 14:08 bartjacobs New Issue
2017-07-25 14:08 bartjacobs File Added: ocamlopt.opt_2017-07-25-134408_Bart-Jacobss-MacBook-Pro.crash
2017-07-25 21:38 gasche Note Added: 0018137
2017-07-25 22:30 gasche Relationship added related to 0007599
2017-09-21 10:32 xleroy Note Added: 0018306
2017-09-21 10:32 xleroy Status new => acknowledged
2017-09-21 10:32 xleroy Target Version => 4.06.0+dev
2017-10-05 17:39 doligez Note Added: 0018487
2017-10-05 17:39 doligez Assigned To => doligez
2017-10-05 17:39 doligez Status acknowledged => assigned
2017-10-13 20:55 frisch Note Added: 0018561
2017-10-13 21:43 gasche Note Added: 0018563
2017-10-19 15:24 xleroy Note Added: 0018590
2017-10-19 15:24 xleroy Status assigned => resolved
2017-10-19 15:24 xleroy Resolution open => fixed
2017-10-19 15:24 xleroy Fixed in Version => 4.06.0+dev


Copyright © 2000 - 2011 MantisBT Group
Powered by Mantis Bugtracker